/* File generated by: simse.codegenerator.enginegenerator.StartingNarrativeDialogGenerator */
package simse.engine;

import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;

public class StartingNarrativeDialog extends JDialog implements ActionListener
{
private JTextArea textArea;
private JButton okButton;

public StartingNarrativeDialog(JFrame owner)
{
super(owner, true);

setTitle("Welcome!");

// Create main panel (box):
Box mainPane = Box.createVerticalBox();
mainPane.setMaximumSize(new Dimension(300, 300));

// Create text area panel:
textArea = new JTextArea(15, 30);
textArea.setLineWrap(true);
textArea.setWrapStyleWord(true);
textArea.setEditable(false);
textArea.setText("This is an open-ended process simulation. Your project is broken up into 4 modules, each of which can have its own requirements progress, design, implementation, etc. In the end, you will want to integrate all of these modules and submit a single, unified project to the customer. There are a wide variety of possible approaches to completing this project; your progress might resemble a waterfall model, a rapid prototype model, a spiral model, or take on the manner of another approach altogether.\n\nThere are several important values that each module has:\n\nValue: The amount by which the module influences your final score.\n\nInflexibility: The degree to which inaccuracy will reduce your score for this module.\n\nChangability: The average number of ticks that it will take for a change to take place on this module. Each change will reduce the modules accuracy.\n\nAccuracy: This represents how accurately the project represents what the customer wants. Keep in mind that this is orthogonal to the completeness of the project.\n\n\nThe following actions can be taken on each module:\n\nRisk analysis: Reveals the value, inflexibility and changability of the module when completed.\n\nDifficulty Analysis: Reveals the difficulty of each of the actions for this module, with a small amount of error.\n\nRequirements: Increases ease of design, increases the projects accuracy and reduces the changability\n\nDesign: Increases ease of implementation and integration, makes it easier to evolve code\n\nImplementation: Determines the modules overall completeness\n\nEvolution: Increases accuracy, but decreases design\n\nIntegrate: You must integrate modules to submit a multiple-module build to the customer\n\nStart over: Removes most of the progress from most of your phases\n\nSubmission to user: Many attributes are roughly revealed, the difficulty of all lifecycle phases is reduced, changability is greatly reduced and the requirements difficulty of all other modules is reduced as well. The usefulness of this action depends on the modules implementation completeness and accuracy.\n\nSubmission of a multiple-module build: If you have fully integrated more than one module, you may submit them as a single large build, which carries even greater benefits than a single module submission.\n\nNote: This model ignores several aspects of the software process, including tools, budget concerns and personnel issues.\n\nTry not to get frustrated if the customer's changes confound your progress, overcoming this is one of the model's primary challenges. Try lots of different approaches and discover what works!" + "");
textArea.setCaretPosition(0);
JScrollPane scrollPane = new JScrollPane(textArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
mainPane.add(scrollPane);

// Create okButton pane and button:
JPanel okButtonPane = new JPanel();
okButton = new JButton("OK");
okButton.addActionListener(this);
okButtonPane.add(okButton);
mainPane.add(okButtonPane);

// Set main window frame properties:
setBackground(Color.black);
setContentPane(mainPane);
validate();
pack();
repaint();
toFront();
// Make it show up in the center of the screen:
Point ownerLoc = owner.getLocationOnScreen();
Point thisLoc = new Point();
thisLoc.setLocation((ownerLoc.getX() + (owner.getWidth() / 2) - (this.getWidth() / 2)), (ownerLoc.getY() + (owner.getHeight() / 2) - (this.getHeight() / 2)));
setLocation(thisLoc);
setVisible(true);
}

public void actionPerformed(ActionEvent evt) // handles user actions
{
Object source = evt.getSource();
if(source == okButton)
{
setVisible(false);
dispose();
}
}
}