/* File generated by: simse.codegenerator.explanatorytoolgenerator.ActionGraphGenerator */
package simse.explanatorytool;

import simse.adts.actions.*;
import simse.SimSE;
import simse.state.Clock;
import simse.state.logger.Logger;
import simse.state.State;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartMouseEvent;
import org.jfree.chart.ChartMouseListener;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartRenderingInfo;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.axis.ValueAxis;
import org.jfree.chart.entity.ChartEntity;
import org.jfree.chart.entity.XYItemEntity;
import org.jfree.chart.labels.AbstractXYItemLabelGenerator;
import org.jfree.chart.labels.XYToolTipGenerator;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.Range;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.ui.RectangleEdge;
import org.jfree.ui.RectangleInsets;
import org.jfree.ui.RefineryUtilities;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.awt.Point;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;

public class ActionGraph extends JFrame implements ChartMouseListener, MouseListener, ActionListener {
private ArrayList<State> log;
private String[] actionNames;
private JFreeChart chart; // chart object
private ChartPanel chartPanel;
private JMenuItem newBranchItem;
private JSeparator separator;
private int lastRightClickedX; // last x-val that was right-clicked on
private XYSeriesCollection dataset;
private Branch branch; // branch from which this action graph is generated
private Hashtable<Integer, XYSeries> series = new Hashtable<Integer, XYSeries>(); // a Hashtable to map action ids to XYSeries
private ArrayList<String> indices = new ArrayList<String>(); // an ArrayList to map action indices to series names
private int actionIndex = 1; // counter for used action indices to be used for their y-values

public ActionGraph(ArrayList<State> log, String[] actionNames, boolean showChart, Branch branch) {
super();
String title = "Action Graph";
if (branch.getName() != null) {
title = title.concat(" - " + branch.getName());
}
setTitle(title);
this.log = log;
this.actionNames = actionNames;
lastRightClickedX = 0;

// add dummy entries for 0 positions (since we don't want to display a series on the 0 line):


// create dataset:
dataset = new XYSeriesCollection();
XYDataset xydataset = createDataset();
chart = createChart(xydataset);
chartPanel = new ChartPanel(chart);
chartPanel.addChartMouseListener(this);
chartPanel.addMouseListener(this);
chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
setContentPane(chartPanel);
newBranchItem = new JMenuItem("Start new branch from here");
newBranchItem.addActionListener(this);
separator = new JSeparator();
pack();
RefineryUtilities.centerFrameOnScreen(this);
setVisible(showChart);
}

// Creates the dataset for this graph
private XYDataset createDataset() {
// add a dummy entry for index 0:
indices.add(0, "Action");
// go through each action:
for (int i = 0; i < actionNames.length; i++) {
}
return dataset;
}

// Creates the chart for this graph
private JFreeChart createChart(XYDataset dataset) {
// create the chart:
JFreeChart chart = ChartFactory.createXYLineChart("Action Graph", "Clock Ticks", null, dataset, PlotOrientation.VERTICAL, true, true, false);
chart.setBackgroundPaint(Color.WHITE);
XYPlot plot = (XYPlot) chart.getPlot();
plot.getRenderer().setToolTipGenerator(new ActionGraphToolTipGenerator());
plot.setBackgroundPaint(new Color(0xFF, 0xFF, 0xCC));
plot.setAxisOffset(new RectangleInsets(5.0, 5.0, 5.0, 5.0));
plot.setDomainGridlinePaint(Color.BLACK);
plot.setRangeGridlinePaint(Color.BLACK);
ValueAxis rangeAxis = plot.getRangeAxis();
rangeAxis.setTickLabelsVisible(false);
rangeAxis.setTickMarksVisible(false);
rangeAxis.setAxisLineVisible(false);
rangeAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());
plot.getDomainAxis().setStandardTickUnits(NumberAxis.createIntegerTickUnits());
XYLineAndShapeRenderer renderer = (XYLineAndShapeRenderer)plot.getRenderer();
renderer.setShapesVisible(true);
renderer.setShapesFilled(true);

// change the auto tick unit selection to integer units only:
NumberAxis domainAxis = (NumberAxis) plot.getDomainAxis();
domainAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());

return chart;
}

private void updateSeries(simse.adts.actions.Action action, int clockTick) {
// if a series has not been created for this action, create one:
if (!series.containsKey(new Integer(action.getId()))) {
XYSeries newSeries = null;
String newSeriesName = "";
// add the data value to the series:
newSeries.add(clockTick, actionIndex);

// add the series to the Hashtable:
series.put(new Integer(action.getId()), newSeries);

// add the index entry to the ArrayList:
indices.add(actionIndex, newSeriesName);
dataset.addSeries(newSeries);

// update the index for the next new action:
actionIndex++;
}
else {
XYSeries oldSeries = series.get(new Integer(action.getId()));
int index = 0;
}
}

// responds to LEFT mouse clicks on the chart
public void chartMouseClicked(ChartMouseEvent event) {
if (event.getTrigger().getButton() == MouseEvent.BUTTON1) { // left-click
ChartEntity entity = event.getEntity();
if ((entity != null) && (entity instanceof XYItemEntity)) {
XYItemEntity xyEntity = (XYItemEntity) entity;

// get the x-value of the action (clock tick):
int xVal = (int) xyEntity.getDataset().getXValue(xyEntity.getSeriesIndex(), xyEntity.getItem());

// get the y-value of the action (action index):
int yVal = (int) xyEntity.getDataset().getYValue(xyEntity.getSeriesIndex(), xyEntity.getItem());

// get the series name of the action:
String seriesName = indices.get(yVal);

// get the action id:
int actionId = getIdOfActionWithSeriesName(seriesName);

if (actionId > -1) { // valid action
Action action = log.get(xVal).getActionStateRepository().getActionWithId(actionId);
if (action != null) {// bring up ActionInfo window:
new ActionInfoWindow(this, seriesName, action, xVal);
}
}
}
}
}

public void chartMouseMoved(ChartMouseEvent event) {}

// responds to RIGHT-clicks on the chart
public void mouseReleased(MouseEvent me) {
if (me.getButton() != MouseEvent.BUTTON1) { // not left-click
XYPlot plot = chart.getXYPlot();
Range domainRange = plot.getDataRange(plot.getDomainAxis());
if (domainRange != null) { // chart is not blank
Point2D pt = chartPanel.translateScreenToJava2D(new Point(me.getX(), me.getY()));
ChartRenderingInfo info = this.chartPanel.getChartRenderingInfo();
Rectangle2D dataArea = info.getPlotInfo().getDataArea();
NumberAxis domainAxis = (NumberAxis)plot.getDomainAxis();
RectangleEdge domainAxisEdge = plot.getDomainAxisEdge();
double chartX = domainAxis.java2DToValue(pt.getX(), dataArea, domainAxisEdge);
lastRightClickedX = (int)Math.rint(chartX);
if (domainRange != null && lastRightClickedX >= domainRange.getLowerBound() && lastRightClickedX <= domainRange.getUpperBound()) { // clicked within domain range
if (chartPanel.getPopupMenu().getComponentIndex(newBranchItem) == -1) { // no new branch item on menu currently
chartPanel.getPopupMenu().add(separator);
chartPanel.getPopupMenu().add(newBranchItem);
chartPanel.getPopupMenu().pack();
chartPanel.getPopupMenu().repaint();
}
}
else { // clicked outside of domain range
if (chartPanel.getPopupMenu().getComponentIndex(newBranchItem) >= 0) { // new branch item currently on menu
chartPanel.getPopupMenu().remove(newBranchItem);
if (chartPanel.getPopupMenu().getComponentIndex(separator) >= 0) { // has separator
chartPanel.getPopupMenu().remove(separator);
}
chartPanel.getPopupMenu().pack();
chartPanel.getPopupMenu().repaint();
}
}
}
}
}

public void mousePressed(MouseEvent me) {}

public void mouseClicked(MouseEvent me) {}

public void mouseEntered(MouseEvent me) {}

public void mouseExited(MouseEvent me) {}

public void actionPerformed(ActionEvent e) {
if (e.getSource() == newBranchItem) {
String newBranchName = JOptionPane.showInputDialog(null, "Please name this new game:", "Name New Game",  JOptionPane.QUESTION_MESSAGE);
if (newBranchName != null) {
State tempState = (State) log.get(lastRightClickedX).clone();
Logger tempLogger = new Logger(tempState, new ArrayList<State>(log.subList(0, lastRightClickedX)));
Clock tempClock = new Clock(tempLogger, lastRightClickedX);
tempState.setClock(tempClock);
tempState.setLogger(tempLogger);
SimSE.startNewBranch(tempState, new Branch(newBranchName, lastRightClickedX, tempClock.getTime(), branch, null));
}
}
}

// returns the id of the action that corresponds to the given series name
private int getIdOfActionWithSeriesName(String seriesName) {
Enumeration<Integer> keys = series.keys();
while (keys.hasMoreElements()) {
Integer id = keys.nextElement();
XYSeries xys = series.get(id);
if (xys.getKey().equals(seriesName)) {
return id.intValue();
}
}
return -1;
}

public void update() {
if ((log.size() > 0) && (log.get(log.size() - 1) != null)) { // there is a log that has not been graphed yet
// add a new end data point for each series:
// go through each action:
for (int i = 0; i < actionNames.length; i++) {
}
}
}

public XYPlot getXYPlot() {
return chart.getXYPlot();
}

public class ActionGraphToolTipGenerator extends AbstractXYItemLabelGenerator implements XYToolTipGenerator {

public ActionGraphToolTipGenerator() {
super();
}

public String generateToolTip(XYDataset dataset, int series, int item) {
return new String(dataset.getSeriesKey(series) + ": click for Action info");
}
}
}