/* File generated by: simse.codegenerator.explanatorytoolgenerator.ActionInfoPanelGenerator */
package simse.explanatorytool;

import simse.adts.actions.*;
import simse.adts.objects.*;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.Dimension;
import java.util.Vector;

public class ActionInfoPanel extends JPanel implements ListSelectionListener {
private simse.adts.actions.Action action; // action in focus

private JList triggerList; // for choosing which trigger show
private JList destroyerList; // for choosing which destroyer to show
private JTextArea descriptionArea; // for displaying a trigger/destroyer description
private JTextArea actionDescriptionArea; // for displaying the action description

private final int TRIGGER = 0;
private final int DESTROYER = 1;

public ActionInfoPanel(simse.adts.actions.Action action) {
this.action = action;

// Create main panel (box):
Box mainPane = Box.createVerticalBox();
mainPane.setPreferredSize(new Dimension(900, 550));

// Create actionDescription pane and components:
Box actionDescriptionPane = Box.createVerticalBox();
JPanel actionDescriptionTitlePane = new JPanel();
actionDescriptionTitlePane.add(new JLabel("ActionDescription:"));
actionDescriptionPane.add(actionDescriptionTitlePane);
actionDescriptionArea = new JTextArea(1, 50);
actionDescriptionArea.setLineWrap(true);
actionDescriptionArea.setWrapStyleWord(true);
actionDescriptionArea.setEditable(false);
JScrollPane actionDescriptionScrollPane = new JScrollPane(actionDescriptionArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
initializeActionDescription();
actionDescriptionPane.add(actionDescriptionScrollPane);

// Create participants pane and components:
Box participantsPane = Box.createVerticalBox();
JPanel participantsTitlePane = new JPanel();
participantsTitlePane.add(new JLabel("Participants:"));
participantsPane.add(participantsTitlePane);

// participants table:
JScrollPane participantsTablePane = new JScrollPane(createParticipantsTable());
participantsTablePane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
participantsTablePane.setPreferredSize(new Dimension(900, 125));
participantsPane.add(participantsTablePane);

// Create triggerDestroyer pane and components:
JPanel triggerDestroyerPane = new JPanel();

// list pane:
Box listPane = Box.createVerticalBox();

// trigger list:
JPanel triggerListTitlePane = new JPanel();
triggerListTitlePane.add(new JLabel("Triggers:"));
listPane.add(triggerListTitlePane);
triggerList = new JList();
triggerList.setVisibleRowCount(3);
triggerList.setFixedCellWidth(400);
triggerList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
triggerList.addListSelectionListener(this);
initializeTriggerList();
JScrollPane triggerListPane = new JScrollPane(triggerList);
listPane.add(triggerListPane);

// destroyer list:
JPanel destroyerListTitlePane = new JPanel();
destroyerListTitlePane.add(new JLabel("Destroyers:"));
listPane.add(destroyerListTitlePane);
destroyerList = new JList();
destroyerList.setVisibleRowCount(3);
destroyerList.setFixedCellWidth(400);
destroyerList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
destroyerList.addListSelectionListener(this);
initializeDestroyerList();
JScrollPane destroyerListPane = new JScrollPane(destroyerList);
listPane.add(destroyerListPane);

triggerDestroyerPane.add(listPane);

// description pane:
Box descriptionPane = Box.createVerticalBox();
JPanel descriptionTitlePane = new JPanel();
descriptionTitlePane.add(new JLabel("Description:"));
descriptionPane.add(descriptionTitlePane);

// description text area:
descriptionArea = new JTextArea(9, 30);
descriptionArea.setLineWrap(true);
descriptionArea.setWrapStyleWord(true);
descriptionArea.setEditable(false);
JScrollPane descriptionScrollPane = new JScrollPane(descriptionArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
descriptionPane.add(descriptionScrollPane);

triggerDestroyerPane.add(descriptionPane);

// Add panes to main pane:
mainPane.add(actionDescriptionPane);
mainPane.add(participantsPane);
mainPane.add(triggerDestroyerPane);
add(mainPane);

// Set main window frame properties:
setOpaque(true);
validate();
repaint();
}

// responds to list selections
public void valueChanged(ListSelectionEvent e) {
if (e.getSource() == triggerList && triggerList.getSelectedIndex() >= 0) {
refreshDescriptionArea(TRIGGER);

// clear selection for destroyer list:
destroyerList.clearSelection();

}
else if (e.getSource() == destroyerList && destroyerList.getSelectedIndex() >= 0) {
refreshDescriptionArea(DESTROYER);

// clear selection for trigger list:
triggerList.clearSelection();
}
}

// initializes the action description
private void initializeActionDescription() {
String text = "";
actionDescriptionArea.setText(text);
actionDescriptionArea.setCaretPosition(0);
}

// initializes the JList of triggers
private void initializeTriggerList() {
}

// initializes the JList of destroyers
private void initializeDestroyerList() {
}

private JTable createParticipantsTable() {
String[] columnNames = { "Participant Name", "Participant", "Status" };
Object[][] data = new Object[action.getAllParticipants().size()][3];
int index = 0;
return new JTable(data, columnNames);
}

// refreshes the description area with the selected trigger/destroyer
private void refreshDescriptionArea(int trigOrDest) {
String name = trigOrDest == TRIGGER ? (String) triggerList.getSelectedValue() : (String) destroyerList.getSelectedValue();
if (name != null) {
String text = "";
descriptionArea.setText(text);
descriptionArea.setCaretPosition(0);
}
}
}