/* File generated by: simse.codegenerator.explanatorytoolgenerator.ObjectGraphGenerator */
package simse.explanatorytool;

import simse.adts.objects.*;
import simse.state.*;
import simse.state.logger.Logger;
import simse.SimSE;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.ChartRenderingInfo;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.axis.NumberAxis;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.renderer.xy.XYLineAndShapeRenderer;
import org.jfree.data.Range;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.ui.RectangleEdge;
import org.jfree.ui.RectangleInsets;
import org.jfree.ui.RefineryUtilities;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.awt.Point;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JSeparator;

public class ObjectGraph extends JFrame implements MouseListener, ActionListener {
private ArrayList<State> log;
private String objTypeType;
private String objType;
private String keyAttVal;
private String[] attributes;
private JFreeChart chart; // chart object
private ChartPanel chartPanel;
private JMenuItem newBranchItem;
private JSeparator separator;
private int lastRightClickedX; // last x-val that was right-clicked on
private XYSeries[] series;
private Branch branch; // branch from which this graph is generated

public ObjectGraph(String title, ArrayList<State> log, String objTypeType, String objType, String keyAttVal, String[] attributes, boolean showChart, Branch branch) {
super();
this.branch = branch;
if (branch.getName() != null) {
title = title.concat(" - " + branch.getName());
}
setTitle(title);
this.log = log;
this.objTypeType = objTypeType;
this.objType = objType;
this.keyAttVal = keyAttVal;
this.attributes = attributes;
lastRightClickedX = 0;
XYDataset dataset = createDataset();
chart = createChart(dataset);
chartPanel = new ChartPanel(chart);
chartPanel.addMouseListener(this);
chartPanel.setPreferredSize(new java.awt.Dimension(500, 270));
setContentPane(chartPanel);
newBranchItem = new JMenuItem("Start new game from here");
newBranchItem.addActionListener(this);
separator = new JSeparator();
pack();
RefineryUtilities.centerFrameOnScreen(this);
setVisible(showChart);
}

// Creates the dataset for this graph
private XYDataset createDataset() {
series = new XYSeries[attributes.length];
for (int i = 0; i < attributes.length; i++) {
series[i] = new XYSeries(attributes[i]);
}

for (int i = 0; i < log.size(); i++) {
for (int j = 0; j < attributes.length; j++) {
if (objTypeType.equals("Artifact") && objType.equals("Module")) {
Module module = null;
if (keyAttVal.equals("Module1")) {
module = log.get(i).getArtifactStateRepository().getModuleStateRepository().get("Module1");
}
else if (keyAttVal.equals("Module2")) {
module = log.get(i).getArtifactStateRepository().getModuleStateRepository().get("Module2");
}
else if (keyAttVal.equals("Module3")) {
module = log.get(i).getArtifactStateRepository().getModuleStateRepository().get("Module3");
}
else if (keyAttVal.equals("Module4")) {
module = log.get(i).getArtifactStateRepository().getModuleStateRepository().get("Module4");
}
if (module != null) {
if (attributes[j].equals("RequirementsProgress")) {
series[j].add(i, module.getRequirementsProgress());
}
else if (attributes[j].equals("DesignProgress")) {
series[j].add(i, module.getDesignProgress());
}
else if (attributes[j].equals("ImplementationProgress")) {
series[j].add(i, module.getImplementationProgress());
}
else if (attributes[j].equals("Accuracy")) {
series[j].add(i, module.getAccuracy());
}
else if (attributes[j].equals("RequirementsDifficulty")) {
series[j].add(i, module.getRequirementsDifficulty());
}
else if (attributes[j].equals("DesignDifficulty")) {
series[j].add(i, module.getDesignDifficulty());
}
else if (attributes[j].equals("ImplementationDifficulty")) {
series[j].add(i, module.getImplementationDifficulty());
}
else if (attributes[j].equals("Value")) {
series[j].add(i, module.getValue());
}
else if (attributes[j].equals("Inflexibility")) {
series[j].add(i, module.getInflexibility());
}
else if (attributes[j].equals("Changability")) {
series[j].add(i, module.getChangability());
}
else if (attributes[j].equals("TotalSatisfaction")) {
series[j].add(i, module.getTotalSatisfaction());
}
else if (attributes[j].equals("KnownValue")) {
series[j].add(i, module.getKnownValue());
}
else if (attributes[j].equals("KnownInflexibility")) {
series[j].add(i, module.getKnownInflexibility());
}
else if (attributes[j].equals("KnownRequirementsDifficulty")) {
series[j].add(i, module.getKnownRequirementsDifficulty());
}
else if (attributes[j].equals("KnownDesignDifficulty")) {
series[j].add(i, module.getKnownDesignDifficulty());
}
else if (attributes[j].equals("KnownImplementationDifficulty")) {
series[j].add(i, module.getKnownImplementationDifficulty());
}
else if (attributes[j].equals("KnownChangability")) {
series[j].add(i, module.getKnownChangability());
}
else if (attributes[j].equals("RiskAnalysisProgress")) {
series[j].add(i, module.getRiskAnalysisProgress());
}
else if (attributes[j].equals("DifficultyAnalysisProgress")) {
series[j].add(i, module.getDifficultyAnalysisProgress());
}
else if (attributes[j].equals("Modifiability")) {
series[j].add(i, module.getModifiability());
}
else if (attributes[j].equals("ChangeTicks")) {
series[j].add(i, module.getChangeTicks());
}
else if (attributes[j].equals("IntegrationDifficulty")) {
series[j].add(i, module.getIntegrationDifficulty());
}
else if (attributes[j].equals("IntegrationProgress")) {
series[j].add(i, module.getIntegrationProgress());
}
else if (attributes[j].equals("InitialRequirementsDifficulty")) {
series[j].add(i, module.getInitialRequirementsDifficulty());
}
else if (attributes[j].equals("InitialDesignDifficulty")) {
series[j].add(i, module.getInitialDesignDifficulty());
}
else if (attributes[j].equals("InitialImplementationDifficulty")) {
series[j].add(i, module.getInitialImplementationDifficulty());
}
else if (attributes[j].equals("InitialIntegrationDifficulty")) {
series[j].add(i, module.getInitialIntegrationDifficulty());
}
else if (attributes[j].equals("KnownIntegrationDifficulty")) {
series[j].add(i, module.getKnownIntegrationDifficulty());
}
}
}
else if (objTypeType.equals("Project") && objType.equals("SEProject")) {
SEProject seproject = null;
if (keyAttVal.equals("TheBigProject")) {
seproject = log.get(i).getProjectStateRepository().getSEProjectStateRepository().get("TheBigProject");
}
if (seproject != null) {
if (attributes[j].equals("TimeAllotted")) {
series[j].add(i, seproject.getTimeAllotted());
}
else if (attributes[j].equals("CurrentTime")) {
series[j].add(i, seproject.getCurrentTime());
}
else if (attributes[j].equals("Satisfaction")) {
series[j].add(i, seproject.getSatisfaction());
}
else if (attributes[j].equals("Score")) {
series[j].add(i, seproject.getScore());
}
}
}
else if (objTypeType.equals("Employee") && objType.equals("SoftwareEngineer")) {
SoftwareEngineer softwareengineer = null;
if (keyAttVal.equals("Amy")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Amy");
}
else if (keyAttVal.equals("Bob")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Bob");
}
else if (keyAttVal.equals("Karl")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Karl");
}
else if (keyAttVal.equals("Lola")) {
softwareengineer = log.get(i).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Lola");
}
if (softwareengineer != null) {
if (attributes[j].equals("RiskAnalysis")) {
series[j].add(i, softwareengineer.getRiskAnalysis());
}
else if (attributes[j].equals("Requirements")) {
series[j].add(i, softwareengineer.getRequirements());
}
else if (attributes[j].equals("Design")) {
series[j].add(i, softwareengineer.getDesign());
}
else if (attributes[j].equals("Implementation")) {
series[j].add(i, softwareengineer.getImplementation());
}
}
}
}
}
XYSeriesCollection dataset = new XYSeriesCollection();
for (int i = 0; i < series.length; i++) {
dataset.addSeries(series[i]);
}
return dataset;
}

// Creates the chart for this graph
private JFreeChart createChart(XYDataset dataset) {
// create the chart:
JFreeChart chart = ChartFactory.createXYLineChart(this.getTitle(), "Clock Ticks", null, dataset, PlotOrientation.VERTICAL, true, true, false);
chart.setBackgroundPaint(Color.white);
XYPlot plot = (XYPlot) chart.getPlot();
plot.setBackgroundPaint(Color.lightGray);
plot.setAxisOffset(new RectangleInsets(5.0, 5.0, 5.0, 5.0));
plot.setDomainGridlinePaint(Color.white);
plot.setRangeGridlinePaint(Color.white);
XYLineAndShapeRenderer renderer = (XYLineAndShapeRenderer) plot.getRenderer();
renderer.setShapesVisible(true);
renderer.setShapesFilled(true);

// change the auto tick unit selection to integer units only:
NumberAxis domainAxis = (NumberAxis) plot.getDomainAxis();
domainAxis.setStandardTickUnits(NumberAxis.createIntegerTickUnits());

return chart;
}

public void update() {
if ((log.size() > 0) && (log.get(log.size() - 1) != null)) { // there is a log that has not been graphed yet
// add a new end data point for each series/attribute
for (int j = 0; j < attributes.length; j++) {
if (objTypeType.equals("Artifact") && objType.equals("Module")) {
Module module = null;
if (keyAttVal.equals("Module1")) {
module = log.get(log.size() - 1).getArtifactStateRepository().getModuleStateRepository().get("Module1");
}
else if (keyAttVal.equals("Module2")) {
module = log.get(log.size() - 1).getArtifactStateRepository().getModuleStateRepository().get("Module2");
}
else if (keyAttVal.equals("Module3")) {
module = log.get(log.size() - 1).getArtifactStateRepository().getModuleStateRepository().get("Module3");
}
else if (keyAttVal.equals("Module4")) {
module = log.get(log.size() - 1).getArtifactStateRepository().getModuleStateRepository().get("Module4");
}
if (module != null) {
if (attributes[j].equals("RequirementsProgress")) {
series[j].add(log.size(), module.getRequirementsProgress());
}
else if (attributes[j].equals("DesignProgress")) {
series[j].add(log.size(), module.getDesignProgress());
}
else if (attributes[j].equals("ImplementationProgress")) {
series[j].add(log.size(), module.getImplementationProgress());
}
else if (attributes[j].equals("Accuracy")) {
series[j].add(log.size(), module.getAccuracy());
}
else if (attributes[j].equals("RequirementsDifficulty")) {
series[j].add(log.size(), module.getRequirementsDifficulty());
}
else if (attributes[j].equals("DesignDifficulty")) {
series[j].add(log.size(), module.getDesignDifficulty());
}
else if (attributes[j].equals("ImplementationDifficulty")) {
series[j].add(log.size(), module.getImplementationDifficulty());
}
else if (attributes[j].equals("Value")) {
series[j].add(log.size(), module.getValue());
}
else if (attributes[j].equals("Inflexibility")) {
series[j].add(log.size(), module.getInflexibility());
}
else if (attributes[j].equals("Changability")) {
series[j].add(log.size(), module.getChangability());
}
else if (attributes[j].equals("TotalSatisfaction")) {
series[j].add(log.size(), module.getTotalSatisfaction());
}
else if (attributes[j].equals("KnownValue")) {
series[j].add(log.size(), module.getKnownValue());
}
else if (attributes[j].equals("KnownInflexibility")) {
series[j].add(log.size(), module.getKnownInflexibility());
}
else if (attributes[j].equals("KnownRequirementsDifficulty")) {
series[j].add(log.size(), module.getKnownRequirementsDifficulty());
}
else if (attributes[j].equals("KnownDesignDifficulty")) {
series[j].add(log.size(), module.getKnownDesignDifficulty());
}
else if (attributes[j].equals("KnownImplementationDifficulty")) {
series[j].add(log.size(), module.getKnownImplementationDifficulty());
}
else if (attributes[j].equals("KnownChangability")) {
series[j].add(log.size(), module.getKnownChangability());
}
else if (attributes[j].equals("RiskAnalysisProgress")) {
series[j].add(log.size(), module.getRiskAnalysisProgress());
}
else if (attributes[j].equals("DifficultyAnalysisProgress")) {
series[j].add(log.size(), module.getDifficultyAnalysisProgress());
}
else if (attributes[j].equals("Modifiability")) {
series[j].add(log.size(), module.getModifiability());
}
else if (attributes[j].equals("ChangeTicks")) {
series[j].add(log.size(), module.getChangeTicks());
}
else if (attributes[j].equals("IntegrationDifficulty")) {
series[j].add(log.size(), module.getIntegrationDifficulty());
}
else if (attributes[j].equals("IntegrationProgress")) {
series[j].add(log.size(), module.getIntegrationProgress());
}
else if (attributes[j].equals("InitialRequirementsDifficulty")) {
series[j].add(log.size(), module.getInitialRequirementsDifficulty());
}
else if (attributes[j].equals("InitialDesignDifficulty")) {
series[j].add(log.size(), module.getInitialDesignDifficulty());
}
else if (attributes[j].equals("InitialImplementationDifficulty")) {
series[j].add(log.size(), module.getInitialImplementationDifficulty());
}
else if (attributes[j].equals("InitialIntegrationDifficulty")) {
series[j].add(log.size(), module.getInitialIntegrationDifficulty());
}
else if (attributes[j].equals("KnownIntegrationDifficulty")) {
series[j].add(log.size(), module.getKnownIntegrationDifficulty());
}
}
}
else if (objTypeType.equals("Project") && objType.equals("SEProject")) {
SEProject seproject = null;
if (keyAttVal.equals("TheBigProject")) {
seproject = log.get(log.size() - 1).getProjectStateRepository().getSEProjectStateRepository().get("TheBigProject");
}
if (seproject != null) {
if (attributes[j].equals("TimeAllotted")) {
series[j].add(log.size(), seproject.getTimeAllotted());
}
else if (attributes[j].equals("CurrentTime")) {
series[j].add(log.size(), seproject.getCurrentTime());
}
else if (attributes[j].equals("Satisfaction")) {
series[j].add(log.size(), seproject.getSatisfaction());
}
else if (attributes[j].equals("Score")) {
series[j].add(log.size(), seproject.getScore());
}
}
}
else if (objTypeType.equals("Employee") && objType.equals("SoftwareEngineer")) {
SoftwareEngineer softwareengineer = null;
if (keyAttVal.equals("Amy")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Amy");
}
else if (keyAttVal.equals("Bob")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Bob");
}
else if (keyAttVal.equals("Karl")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Karl");
}
else if (keyAttVal.equals("Lola")) {
softwareengineer = log.get(log.size() - 1).getEmployeeStateRepository().getSoftwareEngineerStateRepository().get("Lola");
}
if (softwareengineer != null) {
if (attributes[j].equals("RiskAnalysis")) {
series[j].add(log.size(), softwareengineer.getRiskAnalysis());
}
else if (attributes[j].equals("Requirements")) {
series[j].add(log.size(), softwareengineer.getRequirements());
}
else if (attributes[j].equals("Design")) {
series[j].add(log.size(), softwareengineer.getDesign());
}
else if (attributes[j].equals("Implementation")) {
series[j].add(log.size(), softwareengineer.getImplementation());
}
}
}
}
}
}

// responds to RIGHT-clicks on the chart
public void mouseReleased(MouseEvent me) {
if (me.getButton() != MouseEvent.BUTTON1) { // not left-click
XYPlot plot = chart.getXYPlot();
Range domainRange = plot.getDataRange(plot.getDomainAxis());
if (domainRange != null) { // chart is not blank
Point2D pt = chartPanel.translateScreenToJava2D(new Point(me.getX(), me.getY()));
ChartRenderingInfo info = this.chartPanel.getChartRenderingInfo();
Rectangle2D dataArea = info.getPlotInfo().getDataArea();
NumberAxis domainAxis = (NumberAxis)plot.getDomainAxis();
RectangleEdge domainAxisEdge = plot.getDomainAxisEdge();
double chartX = domainAxis.java2DToValue(pt.getX(), dataArea, domainAxisEdge);
lastRightClickedX = (int)Math.rint(chartX);
if (domainRange != null && lastRightClickedX >= domainRange.getLowerBound() && lastRightClickedX <= (domainRange.getUpperBound() - 1) && lastRightClickedX >= 0) { // clicked within domain range
if (chartPanel.getPopupMenu().getComponentIndex(newBranchItem) == -1) { // no new branch item on menu currently
chartPanel.getPopupMenu().add(separator);
chartPanel.getPopupMenu().add(newBranchItem);
chartPanel.getPopupMenu().pack();
chartPanel.getPopupMenu().repaint();
}
}
else { // clicked outside of domain range
if (chartPanel.getPopupMenu().getComponentIndex(newBranchItem) >= 0) { // new branch item currently on menu
chartPanel.getPopupMenu().remove(newBranchItem);
if (chartPanel.getPopupMenu().getComponentIndex(separator) >= 0) { // has separator
chartPanel.getPopupMenu().remove(separator);
}
chartPanel.getPopupMenu().pack();
chartPanel.getPopupMenu().repaint();
}
}
}
}
}
public void mousePressed(MouseEvent me) {}
public void mouseClicked(MouseEvent me) {}
public void mouseEntered(MouseEvent me) {}
public void mouseExited(MouseEvent me) {}

public void actionPerformed(ActionEvent evt) {
if (evt.getSource() == newBranchItem) {
String newBranchName = JOptionPane.showInputDialog(null, "Please name this new game:", "Name New Game", JOptionPane.QUESTION_MESSAGE);
if (newBranchName != null) {
State tempState = (State)log.get(lastRightClickedX).clone();
Logger tempLogger = new Logger(tempState, new ArrayList<State>(log.subList(0, lastRightClickedX)));
Clock tempClock = new Clock(tempLogger, lastRightClickedX);
tempState.setClock(tempClock);
tempState.setLogger(tempLogger);
SimSE.startNewBranch(tempState, new Branch(newBranchName, lastRightClickedX, tempClock.getTime(), branch, null));
}
}
}

public XYPlot getXYPlot() {
return chart.getXYPlot();
}

public String getChartTitle() {
return this.getTitle();
}

public ArrayList<State> getLog() {
return log;
}

public class ExitListener extends WindowAdapter {
public void windowClosing(WindowEvent event) {
setVisible(false);
dispose();
}
}
}