/* File generated by: simse.codegenerator.explanatorytoolgenerator.RuleInfoPanelGenerator */
package simse.explanatorytool;

import simse.adts.actions.*;
import simse.explanatorytool.RuleDescriptions;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import java.awt.Dimension;

public class RuleInfoPanel extends JPanel implements ListSelectionListener {
private simse.adts.actions.Action action; // action in focus

private JList triggerRuleList;
private JList destroyerRuleList;
private JList intermediateRuleList;
private JTextArea descriptionArea; // for displaying a rule description

public RuleInfoPanel(JFrame owner, simse.adts.actions.Action action) {
this.action = action;

// Create main panel:
JPanel mainPane = new JPanel();
mainPane.setPreferredSize(new Dimension(900, 550));

// Create rule pane and components:
Box rulePane = Box.createVerticalBox();
JPanel trigRuleTitlePane = new JPanel();
trigRuleTitlePane.add(new JLabel("Trigger Rules:"));
rulePane.add(trigRuleTitlePane);

// rule lists:
triggerRuleList = new JList();
triggerRuleList.setVisibleRowCount(7);
triggerRuleList.setFixedCellWidth(400);
triggerRuleList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
triggerRuleList.addListSelectionListener(this);
JScrollPane triggerRuleListPane = new JScrollPane(triggerRuleList);
String trigToolTip = "Rules that execute at the beginning of the action";
trigRuleTitlePane.setToolTipText(trigToolTip);
triggerRuleList.setToolTipText(trigToolTip);
rulePane.add(triggerRuleListPane);

JPanel destRuleTitlePane = new JPanel();
destRuleTitlePane.add(new JLabel("Destroyer Rules:"));
rulePane.add(destRuleTitlePane);
destroyerRuleList = new JList();
destroyerRuleList.setVisibleRowCount(7);
destroyerRuleList.setFixedCellWidth(400);
destroyerRuleList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
destroyerRuleList.addListSelectionListener(this);
JScrollPane destroyerRuleListPane = new JScrollPane(destroyerRuleList);
String destToolTip = "Rules that execute at the end of the action";
destRuleTitlePane.setToolTipText(destToolTip);
destroyerRuleList.setToolTipText(destToolTip);
rulePane.add(destroyerRuleListPane);

JPanel intRuleTitlePane = new JPanel();
intRuleTitlePane.add(new JLabel("Intermediate Rules:"));
rulePane.add(intRuleTitlePane);
intermediateRuleList = new JList();
intermediateRuleList.setVisibleRowCount(7);
intermediateRuleList.setFixedCellWidth(400);
intermediateRuleList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
intermediateRuleList.addListSelectionListener(this);
JScrollPane intermediateRuleListPane = new JScrollPane(intermediateRuleList);
String intToolTip = "Rules that execute every clock tick during the life of the action";
intRuleTitlePane.setToolTipText(intToolTip);
intermediateRuleList.setToolTipText(intToolTip);
rulePane.add(intermediateRuleListPane);

initializeRuleLists();

// description pane:
Box descriptionPane = Box.createVerticalBox();
JPanel descriptionTitlePane = new JPanel();
descriptionTitlePane.add(new JLabel("Description:"));
descriptionPane.add(descriptionTitlePane);

// description text area:
descriptionArea = new JTextArea(29, 30);
descriptionArea.setLineWrap(true);
descriptionArea.setWrapStyleWord(true);
descriptionArea.setEditable(false);
JScrollPane descriptionScrollPane = new JScrollPane(descriptionArea, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
descriptionPane.add(descriptionScrollPane);

rulePane.add(descriptionPane);

// Add panes to main pane:
mainPane.add(rulePane);
mainPane.add(descriptionPane);
add(mainPane);

setOpaque(true);
validate();
repaint();
}

public void valueChanged(ListSelectionEvent e) {
if ((e.getSource() == triggerRuleList && !triggerRuleList.isSelectionEmpty())) {
destroyerRuleList.clearSelection();
intermediateRuleList.clearSelection();
refreshDescriptionArea();
}
else if (e.getSource() == destroyerRuleList && !destroyerRuleList.isSelectionEmpty()) {
triggerRuleList.clearSelection();
intermediateRuleList.clearSelection();
refreshDescriptionArea();
}
else if (e.getSource() == intermediateRuleList && !intermediateRuleList.isSelectionEmpty()) {
triggerRuleList.clearSelection();
destroyerRuleList.clearSelection();
refreshDescriptionArea();
}
}

private void initializeRuleLists() {
}

// refreshes the description area with the selected rule description
private void refreshDescriptionArea() {
String name = null;
if (!triggerRuleList.isSelectionEmpty()) {
name = (String) triggerRuleList.getSelectedValue();
}
else if (!destroyerRuleList.isSelectionEmpty()) {
name = (String) destroyerRuleList.getSelectedValue();
}
else if (!intermediateRuleList.isSelectionEmpty()) {
name = (String) intermediateRuleList.getSelectedValue();
}
if (name != null) {
String text = "";
descriptionArea.setText(text);
descriptionArea.setCaretPosition(0);
}
}
}