/* File generated by: simse.codegenerator.guigenerator.AtAGlanceFramesGenerator */
package simse.gui;

import simse.state.*;

import java.awt.event.*;
import java.awt.*;
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import java.util.*;
import java.text.*;
import java.awt.Color;

public class ArtifactsAtAGlanceFrame extends JFrame implements MouseListener, ActionListener
{

private State state;

private JPopupMenu popup;
private PopupListener popupListener;
private JTable moduleTable;
private ModuleTableModel moduleModel;
private JPanel moduleTitlePane;
private JPanel mainPane;

private int realColumnIndex; // index of selected column
private JTable selectedTable; // selected table

public ArtifactsAtAGlanceFrame(State s,SimSEGUI gui)
{
state = s;
// Set window title:
setTitle("Artifacts At-A-Glance");

// Create tables:
int numCols;

moduleModel = new ModuleTableModel(s);
moduleTable = new JTable(moduleModel);
moduleTable.setColumnSelectionAllowed(false);
moduleTable.setRowSelectionAllowed(false);
moduleTable.addMouseListener(this);
moduleTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = moduleTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
moduleTable.getColumnModel().getColumn(i).setMinWidth(0);
}

// right click menu:
popup = new JPopupMenu();
popupListener = new PopupListener(popup,gui);

// Create panes:
JScrollPane modulePane = new JScrollPane(moduleTable);

// Table headers:
moduleTitlePane = new JPanel();
moduleTitlePane.add(new JLabel("Modules:"));

// Create main pane:
mainPane = new JPanel();
mainPane.setLayout(new BoxLayout(mainPane, BoxLayout.Y_AXIS));

// Add panes to main pane:
mainPane.add(moduleTitlePane);
mainPane.add(modulePane);

// Set main window frame properties:
setBackground(Color.white);
setContentPane(mainPane);
setVisible(false);
pack();
validate();

resetHeight();
}


public void mousePressed(MouseEvent me){}
public void mouseClicked(MouseEvent me){}
public void mouseEntered(MouseEvent me){}
public void mouseExited(MouseEvent me){}

public void mouseReleased(MouseEvent me)
{
Point p = me.getPoint();

if(me.isPopupTrigger())
{
if(me.getComponent().equals(moduleTable)) // correct table
{
createPopupMenu(moduleTable, p);
}
}
}


public void actionPerformed(ActionEvent e)	// dealing with actions generated by popup menus
{
Object source = e.getSource();
if(source instanceof JMenuItem)
{
String itemText = ((JMenuItem)source).getText();
if(itemText.equals("Hide"))
{
if(selectedTable != null)
{
selectedTable.getColumnModel().getColumn(realColumnIndex).setMaxWidth(0);
}
}
else // an item on the "Unhide" menu
{
if(selectedTable != null)
{
TableModel model = selectedTable.getModel();
TableColumn column = null;
if(model instanceof ModuleTableModel)
{
column = selectedTable.getColumnModel().getColumn(((ModuleTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
if(column != null)
{
column.setMinWidth(0);
column.setMaxWidth(2147483647);
column.setPreferredWidth(selectedTable.getWidth() / (selectedTable.getColumnCount() - getAllHiddenColumnIndices(selectedTable).size() + 1));
}
}
}
}
}


public void createPopupMenu(JTable table, Point p)
{
popup.removeAll();

int colIndex = table.columnAtPoint(p);
realColumnIndex = table.convertColumnIndexToModel(colIndex);

Vector<Integer> hiddenCols = getAllHiddenColumnIndices(table);

if((realColumnIndex >= 0) || (hiddenCols.size() > 0)) // user clicked on a column and/or there is at least one hidden column
{
if(realColumnIndex >= 0)
{
JMenuItem hideItem = new JMenuItem("Hide");
hideItem.addActionListener(this);
popup.add(hideItem);
}

if(hiddenCols.size() > 0) // there is at least one hidden column
{
JMenu unhideMenu = new JMenu("Unhide");
for(int i=0; i<hiddenCols.size(); i++)
{
int index = hiddenCols.elementAt(i).intValue();
JMenuItem tempItem = new JMenuItem(table.getColumnName(index));
tempItem.addActionListener(this);
unhideMenu.add(tempItem);
}
if(popup.getComponents().length > 0) // already has the hide menu item
{
popup.addSeparator();
}
popup.add(unhideMenu);
}

addMouseListener(popupListener);
popup.show(table, (int)p.getX(), (int)p.getY());
selectedTable = table;
repaint();
}
}


public void update()
{
DefaultTableCellRenderer rightAlignRenderer = new DefaultTableCellRenderer();
rightAlignRenderer.setHorizontalAlignment(JLabel.RIGHT);
moduleModel.update();
if (!state.getClock().isStopped()) { // game not over
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("RequirementsProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("DesignProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("ImplementationProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("Accuracy")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("TotalSatisfaction")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownValue")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownInflexibility")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownRequirementsDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownDesignDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownImplementationDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownChangability")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("RiskAnalysisProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("DifficultyAnalysisProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("Modifiability")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("IntegrationProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownIntegrationDifficulty")).setCellRenderer(rightAlignRenderer);
}
else { // game over
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("RequirementsProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("DesignProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("ImplementationProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("Accuracy")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("RequirementsDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("DesignDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("ImplementationDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("Value")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("Inflexibility")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("Changability")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("TotalSatisfaction")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownValue")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownInflexibility")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownRequirementsDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownDesignDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownImplementationDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownChangability")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("RiskAnalysisProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("DifficultyAnalysisProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("Modifiability")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("ChangeTicks")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("IntegrationDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("IntegrationProgress")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("InitialRequirementsDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("InitialDesignDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("InitialImplementationDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("InitialIntegrationDifficulty")).setCellRenderer(rightAlignRenderer);
moduleTable.getColumnModel().getColumn(moduleModel.getColumnIndex("KnownIntegrationDifficulty")).setCellRenderer(rightAlignRenderer);
}
moduleTable.update(moduleTable.getGraphics());
resetHeight();
}
private void resetHeight()
{
// Set appropriate height:
double height = 0;
height += ((moduleTable.getRowHeight() + (moduleTable.getRowMargin() * 2)) * (moduleTable.getRowCount() + 1));
height += moduleTitlePane.getSize().getHeight();

mainPane.setPreferredSize(new Dimension((int)(mainPane.getSize().getWidth()), (int)height));
pack();
validate();
repaint();
}



private Vector<Integer> getAllHiddenColumnIndices(JTable table)
{
Vector<Integer> hiddenCols = new Vector<Integer>();
int numCols = table.getColumnModel().getColumnCount();
for(int i=0; i<numCols; i++)
{
TableColumn col = table.getColumnModel().getColumn(i);
if(col.getWidth() == 0) // hidden
{
hiddenCols.add(new Integer(i));
}
}
return hiddenCols;
}
}