/* File generated by: simse.codegenerator.guigenerator.AttributePanelGenerator */
package simse.gui;
import simse.engine.*;
import simse.state.*;
import simse.adts.objects.*;

import java.text.*;
import java.util.*;
import java.awt.event.*;
import java.awt.*;
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import java.awt.Color;
import java.io.*;

public class AttributePanel extends JPanel
{
private final int ATTRIBUTE_LIST_CAPACITY = 5; // number of attributes that can be displayed in a list without making the list scrollable

private GridBagLayout gbl;
private ClockPanel clockPane;

private State state;
private NumberFormat numFormat;

private JScrollPane attributePaneLeft;
private JScrollPane attributePaneRight;
private JList attributeListLeft;
private JList attributeListRight;

private Vector<String> attributes;
private SSObject objInFocus = null;
private ImageIcon displayedIcon;

private JLabel selectedIcon;
private JPanel iconPanel;

private Image border;
private Image iconBorder;

private boolean guiChanged;

public AttributePanel(SimSEGUI g, State s, Engine e)
{
gbl = new GridBagLayout();
setLayout(gbl);

border = ImageLoader.getImageFromURL("/simse/gui/images/layout/border.gif");
iconBorder = ImageLoader.getImageFromURL("/simse/gui/images/layout/iconBorder.gif");

state = s;
clockPane = new ClockPanel(g,s,e);
clockPane.setPreferredSize(new Dimension(250,100));

numFormat = NumberFormat.getNumberInstance(Locale.US);

attributes = new Vector<String>();

attributeListLeft = new JList();
attributePaneLeft = new JScrollPane(attributeListLeft, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
attributePaneLeft.setPreferredSize(new Dimension(300,95));

attributeListRight = new JList();
attributePaneRight = new JScrollPane(attributeListRight, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
attributePaneRight.setPreferredSize(new Dimension(300,95));

JPanel attributePane = new JPanel();
((FlowLayout)attributePane.getLayout()).setHgap(5);
((FlowLayout)attributePane.getLayout()).setVgap(0);
attributePane.add(attributePaneLeft);
attributePane.add(attributePaneRight);
attributePane.setBackground(new Color(102, 102, 102, 255));

iconPanel = new JPanel(gbl);
iconPanel.setBackground(new Color(0,0,0,0));
iconPanel.setPreferredSize(new Dimension(90,90));
selectedIcon = new JLabel(new ImageIcon(ImageLoader.getImageFromURL("/simse/gui/images/grid.gif")));
selectedIcon.setOpaque(true);
selectedIcon.setPreferredSize(new Dimension(50,50));
selectedIcon.setMinimumSize(new Dimension(50,50));

GridBagConstraints gbc;
gbc = new GridBagConstraints(0,0,1,1, 0,0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(-3,5,0,0), 0,0);
gbl.setConstraints(selectedIcon,gbc);
iconPanel.add(selectedIcon);
add(iconPanel);

gbc = new GridBagConstraints(2, 0, 1, 1, 1, 1, GridBagConstraints.SOUTH, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0);
gbl.setConstraints(attributePane, gbc);
add(attributePane);

gbc = new GridBagConstraints(3, 0, 1, 1, 1, 1, GridBagConstraints.SOUTHEAST, GridBagConstraints.NONE, new Insets(10, 0, 0, 0), 0, 0);
gbl.setConstraints(clockPane,gbc);
add(clockPane);
}


public void paintComponent(Graphics g)
{
Dimension d = getSize();
int width = (int)d.getWidth();
g.setColor(new Color(102,102,102,255));
g.fillRect(0,0,width,110);

// repeat the border across the width of screen:
for (int i = 0; i < width; i+=100)
{
g.drawImage(border,i,0,this);
}
// draw the design for the selectedIcon
g.drawImage(iconBorder,05,11,this);
}


public void setObjectInFocus(SSObject obj, Icon img)
{
objInFocus = obj;
if(img != null)
{
setIcon(img);
}
updateAttributeList();
}


public void update()
{
updateAttributeList();
clockPane.update();
}


public void setGUIChanged()
{
guiChanged = true;
}

private void updateAttributeList()
{
if(false)
{
}
else
{
attributes.clear();

// Employee:
if((objInFocus != null) && state.getEmployeeStateRepository().getAll().contains(objInFocus))
{
if(objInFocus instanceof SoftwareEngineer)
{
SoftwareEngineer p = (SoftwareEngineer)objInFocus;
attributes.add("<html><font size=2>Type: SoftwareEngineer</font></html>");
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>Name: " + p.getName() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>Name: " + p.getName() + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>RiskAnalysisExperience: " + p.getRiskAnalysisExperience() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>RiskAnalysisExperience: " + p.getRiskAnalysisExperience() + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>RequirementsExperience: " + p.getRequirementsExperience() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>RequirementsExperience: " + p.getRequirementsExperience() + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>DesignExperience: " + p.getDesignExperience() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>DesignExperience: " + p.getDesignExperience() + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>ImplementationSkill: " + p.getImplementationSkill() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>ImplementationSkill: " + p.getImplementationSkill() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>RiskAnalysis: " + numFormat.format(p.getRiskAnalysis()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Requirements: " + numFormat.format(p.getRequirements()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Design: " + numFormat.format(p.getDesign()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Implementation: " + numFormat.format(p.getImplementation()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>Description: " + p.getDescription() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>Description: " + p.getDescription() + "</font></html>");
}
}
}
// Artifact:
else if((objInFocus != null) && state.getArtifactStateRepository().getAll().contains(objInFocus))
{
if(objInFocus instanceof Module)
{
Module p = (Module)objInFocus;
attributes.add("<html><font size=2>Type: Module</font></html>");
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>Name: " + p.getName() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>Name: " + p.getName() + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>RequirementsProgress: " + numFormat.format(p.getRequirementsProgress()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>RequirementsProgress: " + numFormat.format(p.getRequirementsProgress()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>DesignProgress: " + numFormat.format(p.getDesignProgress()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>DesignProgress: " + numFormat.format(p.getDesignProgress()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>ImplementationProgress: " + numFormat.format(p.getImplementationProgress()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>ImplementationProgress: " + numFormat.format(p.getImplementationProgress()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Accuracy: " + numFormat.format(p.getAccuracy()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Accuracy: " + numFormat.format(p.getAccuracy()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>RequirementsDifficulty: " + numFormat.format(p.getRequirementsDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>DesignDifficulty: " + numFormat.format(p.getDesignDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>ImplementationDifficulty: " + numFormat.format(p.getImplementationDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Value: " + numFormat.format(p.getValue()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Inflexibility: " + numFormat.format(p.getInflexibility()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Changability: " + numFormat.format(p.getChangability()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>TotalSatisfaction: " + numFormat.format(p.getTotalSatisfaction()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>TotalSatisfaction: " + numFormat.format(p.getTotalSatisfaction()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownValue: " + numFormat.format(p.getKnownValue()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownValue: " + numFormat.format(p.getKnownValue()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownInflexibility: " + numFormat.format(p.getKnownInflexibility()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownInflexibility: " + numFormat.format(p.getKnownInflexibility()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownRequirementsDifficulty: " + numFormat.format(p.getKnownRequirementsDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownRequirementsDifficulty: " + numFormat.format(p.getKnownRequirementsDifficulty()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownDesignDifficulty: " + numFormat.format(p.getKnownDesignDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownDesignDifficulty: " + numFormat.format(p.getKnownDesignDifficulty()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownImplementationDifficulty: " + numFormat.format(p.getKnownImplementationDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownImplementationDifficulty: " + numFormat.format(p.getKnownImplementationDifficulty()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownChangability: " + numFormat.format(p.getKnownChangability()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownChangability: " + numFormat.format(p.getKnownChangability()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>RiskAnalysisProgress: " + numFormat.format(p.getRiskAnalysisProgress()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>RiskAnalysisProgress: " + numFormat.format(p.getRiskAnalysisProgress()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>DifficultyAnalysisProgress: " + numFormat.format(p.getDifficultyAnalysisProgress()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>DifficultyAnalysisProgress: " + numFormat.format(p.getDifficultyAnalysisProgress()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Modifiability: " + numFormat.format(p.getModifiability()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Modifiability: " + numFormat.format(p.getModifiability()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>ChangeTicks: " + numFormat.format(p.getChangeTicks()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>IntegrationDifficulty: " + numFormat.format(p.getIntegrationDifficulty()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>IntegrationProgress: " + numFormat.format(p.getIntegrationProgress()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>IntegrationProgress: " + numFormat.format(p.getIntegrationProgress()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>InitialRequirementsDifficulty: " + numFormat.format(p.getInitialRequirementsDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>InitialDesignDifficulty: " + numFormat.format(p.getInitialDesignDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>InitialImplementationDifficulty: " + numFormat.format(p.getInitialImplementationDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>InitialIntegrationDifficulty: " + numFormat.format(p.getInitialIntegrationDifficulty()) + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownIntegrationDifficulty: " + numFormat.format(p.getKnownIntegrationDifficulty()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>KnownIntegrationDifficulty: " + numFormat.format(p.getKnownIntegrationDifficulty()) + "</font></html>");
}
}
}
// Tool:
else if((objInFocus != null) && state.getToolStateRepository().getAll().contains(objInFocus))
{
}
// Project:
else if((objInFocus != null) && state.getProjectStateRepository().getAll().contains(objInFocus))
{
if(objInFocus instanceof SEProject)
{
SEProject p = (SEProject)objInFocus;
attributes.add("<html><font size=2>Type: SEProject</font></html>");
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>Name: " + p.getName() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>Name: " + p.getName() + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>TimeAllotted: " + p.getTimeAllotted() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>TimeAllotted: " + p.getTimeAllotted() + "</font></html>");
}
if(!state.getClock().isStopped()) // game not over
{
attributes.add("<html><font size=2>CurrentTime: " + p.getCurrentTime() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>CurrentTime: " + p.getCurrentTime() + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Satisfaction: " + numFormat.format(p.getSatisfaction()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
numFormat.setMinimumFractionDigits(0);
numFormat.setMaximumFractionDigits(0);
attributes.add("<html><font size=2>Score: " + numFormat.format(p.getScore()) + "</font></html>");
}
if(state.getClock().isStopped()) // game is over
{
attributes.add("<html><font size=2>Initialized: " + p.getInitialized() + "</font></html>");
}
}
}
// Customer:
else if((objInFocus != null) && state.getCustomerStateRepository().getAll().contains(objInFocus))
{
}
else
{
setIcon(new ImageIcon(ImageLoader.getImageFromURL("/simse/gui/images/grid.gif")));
}

attributeListLeft.setListData(attributes);
attributeListRight.setListData(new Vector());
validate();

// distribute attributes to both sides, if needed:
Vector<String> rightHandAtts = new Vector<String>();
if(attributes.size() > ATTRIBUTE_LIST_CAPACITY) // need to use 2nd list
{
while((ATTRIBUTE_LIST_CAPACITY) < attributes.size()) // there are still more elements to move to right
{
rightHandAtts.add(attributes.remove(ATTRIBUTE_LIST_CAPACITY)); // remove from left, put on right
}
attributeListRight.setListData(rightHandAtts);
attributeListLeft.setListData(attributes);
validate();
repaint();

if(attributePaneLeft.getHorizontalScrollBar().isVisible()) // need to move one more over to account for extra space that
// scrollbar takes up
{
rightHandAtts.add(0, attributes.remove(attributes.size() - 1)); // move
attributeListRight.setListData(rightHandAtts);
attributeListLeft.setListData(attributes);
}
}
repaint();
guiChanged = false;
}
}

public ClockPanel getClockPanel() {
return clockPane;
}

public void setIcon(Icon img)
{
selectedIcon.setBackground(Color.WHITE);
selectedIcon.setIcon(img);
}
}