/* File generated by: simse.codegenerator.logicgenerator.dialoggenerator.EmployeeParticipantSelectionDialogGenerator */
package simse.logic.dialogs;
import simse.gui.ImageLoader;
import simse.gui.TabPanel;
import simse.state.*;
import simse.adts.objects.*;
import simse.adts.actions.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
public class EmployeeParticipantSelectionDialog extends JDialog implements ActionListener
{
private String partName;
private Vector<SSObject> participants;
private simse.adts.actions.Action action;
private State state;
private Employee selectedEmp;
private int minNumParts;
private int maxNumParts;
private Vector<JCheckBox> checkBoxes;
private JButton checkAllButton;
private JButton clearAllButton;
private JButton okButton;
private JButton cancelButton;
private boolean actionCancelled;
public EmployeeParticipantSelectionDialog(JFrame owner, String pName, Vector<SSObject> parts, simse.adts.actions.Action act, State s, Employee emp)
{
super(owner, true);
partName = pName;
participants = parts;
action = act;
state = s;
selectedEmp = emp;
actionCancelled = false;
setMinAndMax();
if(((selectedEmp != null) && (maxNumParts > 0) && (participants.size() > 0)) || ((selectedEmp == null) && (participants.size() > minNumParts)))
{
checkBoxes = new Vector<JCheckBox>();
setTitle("Participant Selection");
Box mainPane = Box.createVerticalBox();
JPanel topPane = new JPanel();
String title = "Choose ";
if(selectedEmp != null) // selected emp already added in this participant role
{
title = title.concat("other ");
}
title = title.concat(partName + " participant(s) (");
if(minNumParts == maxNumParts)
{
title = title.concat("exactly " + minNumParts);
}
else
{
title = title.concat("at least " + minNumParts);
if(maxNumParts < 999999) // not boundless
{
title = title.concat(", at most " + maxNumParts);
}
}
title = title.concat("):");
topPane.add(new JLabel(title));
JPanel middlePane = new JPanel(new GridLayout(0, 1));
for(int i=0; i<participants.size(); i++)
{
SSObject tempObj = participants.elementAt(i);
String label = new String();
if(tempObj instanceof Module)
{
label = ("Module (" + ((Module)tempObj).getName() + ")");
}
else if(tempObj instanceof SEProject)
{
label = ("SEProject (" + ((SEProject)tempObj).getName() + ")");
}
else if(tempObj instanceof SoftwareEngineer)
{
label = ("SoftwareEngineer (" + ((SoftwareEngineer)tempObj).getName() + ")");
}
JPanel tempPane = new JPanel(new BorderLayout());
JCheckBox tempCheckBox = new JCheckBox(label);
tempPane.add(tempCheckBox, BorderLayout.WEST);
checkBoxes.add(tempCheckBox);
ImageIcon icon =  new ImageIcon(ImageLoader.getImageFromURL(TabPanel.getImage(tempObj)).getScaledInstance(30, 30, Image.SCALE_AREA_AVERAGING));
tempPane.add(new JLabel(icon), BorderLayout.EAST);
middlePane.add(tempPane);
}
JPanel checkPane = new JPanel();
checkAllButton = new JButton("Check All");
checkAllButton.addActionListener(this);
checkPane.add(checkAllButton);
clearAllButton = new JButton("Clear All");
clearAllButton.addActionListener(this);
checkPane.add(clearAllButton);
JPanel bottomPane = new JPanel();
okButton = new JButton("OK");
okButton.addActionListener(this);
bottomPane.add(okButton);
cancelButton = new JButton("Cancel");
cancelButton.addActionListener(this);
bottomPane.add(cancelButton);
mainPane.add(topPane);
mainPane.add(middlePane);
JSeparator separator1 = new JSeparator();
separator1.setMaximumSize(new Dimension(900, 1));
mainPane.add(separator1);
mainPane.add(checkPane);
JSeparator separator2 = new JSeparator();
separator2.setMaximumSize(new Dimension(900, 1));
mainPane.add(separator2);
mainPane.add(bottomPane);
addWindowListener(new ExitListener());
setContentPane(mainPane);
validate();
pack();
repaint();
toFront();
Point ownerLoc = owner.getLocationOnScreen();
Point thisLoc = new Point();
thisLoc.setLocation((ownerLoc.getX() + (owner.getWidth() / 2) - (this.getWidth() / 2)), (ownerLoc.getY() + (owner.getHeight() / 2) - (this.getHeight() / 2)));
setLocation(thisLoc);
setVisible(true);
}
else if ((selectedEmp == null) && (participants.size() == minNumParts)) {
for (int i = 0; i < participants.size(); i++) {
Employee tempEmp = (Employee) participants.elementAt(i);
if(action instanceof DesignAction)
{
if(partName.equals("Designer"))
{
((DesignAction)action).addDesigner(tempEmp);
}
}
else if(action instanceof DifficultyAnalysisAction)
{
if(partName.equals("Analyser"))
{
((DifficultyAnalysisAction)action).addAnalyser(tempEmp);
}
}
else if(action instanceof EvolveCodeAction)
{
if(partName.equals("Implementer"))
{
((EvolveCodeAction)action).addImplementer(tempEmp);
}
}
else if(action instanceof ImplementationAction)
{
if(partName.equals("Implementer"))
{
((ImplementationAction)action).addImplementer(tempEmp);
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Implementer"))
{
((IntegrateAction)action).addImplementer(tempEmp);
}
}
else if(action instanceof RequirementsAction)
{
if(partName.equals("ReqEngineer"))
{
((RequirementsAction)action).addReqEngineer(tempEmp);
}
}
else if(action instanceof RiskAnalysisAction)
{
if(partName.equals("Analyser"))
{
((RiskAnalysisAction)action).addAnalyser(tempEmp);
}
}
else if(action instanceof StartOverAction)
{
if(partName.equals("SEngineer"))
{
((StartOverAction)action).addSEngineer(tempEmp);
}
}
else if(action instanceof SubmitFinalAction)
{
if(partName.equals("Implementer"))
{
((SubmitFinalAction)action).addImplementer(tempEmp);
}
}
else if(action instanceof SubmitMultipleAction)
{
if(partName.equals("Implementer"))
{
((SubmitMultipleAction)action).addImplementer(tempEmp);
}
}
else if(action instanceof SubmitOneAction)
{
if(partName.equals("Implementer"))
{
((SubmitOneAction)action).addImplementer(tempEmp);
}
}
}
}if(selectedEmp != null)
{
if(action instanceof DesignAction)
{
if(partName.equals("Designer"))
{
((DesignAction)action).addDesigner(selectedEmp);
}
}
else if(action instanceof DifficultyAnalysisAction)
{
if(partName.equals("Analyser"))
{
((DifficultyAnalysisAction)action).addAnalyser(selectedEmp);
}
}
else if(action instanceof EvolveCodeAction)
{
if(partName.equals("Implementer"))
{
((EvolveCodeAction)action).addImplementer(selectedEmp);
}
}
else if(action instanceof ImplementationAction)
{
if(partName.equals("Implementer"))
{
((ImplementationAction)action).addImplementer(selectedEmp);
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Implementer"))
{
((IntegrateAction)action).addImplementer(selectedEmp);
}
}
else if(action instanceof RequirementsAction)
{
if(partName.equals("ReqEngineer"))
{
((RequirementsAction)action).addReqEngineer(selectedEmp);
}
}
else if(action instanceof RiskAnalysisAction)
{
if(partName.equals("Analyser"))
{
((RiskAnalysisAction)action).addAnalyser(selectedEmp);
}
}
else if(action instanceof StartOverAction)
{
if(partName.equals("SEngineer"))
{
((StartOverAction)action).addSEngineer(selectedEmp);
}
}
else if(action instanceof SubmitFinalAction)
{
if(partName.equals("Implementer"))
{
((SubmitFinalAction)action).addImplementer(selectedEmp);
}
}
else if(action instanceof SubmitMultipleAction)
{
if(partName.equals("Implementer"))
{
((SubmitMultipleAction)action).addImplementer(selectedEmp);
}
}
else if(action instanceof SubmitOneAction)
{
if(partName.equals("Implementer"))
{
((SubmitOneAction)action).addImplementer(selectedEmp);
}
}
}
}

public void actionPerformed(ActionEvent evt)
{
Object source = evt.getSource();
if(source == cancelButton)
{
actionCancelled = true;
setVisible(false);
dispose();
}
else if(source == okButton)
{
Vector<JCheckBox> checkedBoxes = new Vector<JCheckBox>();
for(int i=0; i<checkBoxes.size(); i++)
{
JCheckBox tempCBox = checkBoxes.elementAt(i);
if(tempCBox.isSelected())
{
checkedBoxes.add(tempCBox);
}
}
if(checkedBoxes.size() < minNumParts)
{
JOptionPane.showMessageDialog(null, ("You must choose at least " + minNumParts + " participants"), "Invalid Input", JOptionPane.ERROR_MESSAGE);
}
else if(checkedBoxes.size() > maxNumParts)
{
JOptionPane.showMessageDialog(null, ("You may only choose at most " + maxNumParts + " participants"), "Invalid Input", JOptionPane.ERROR_MESSAGE);
}
else
{
for(int i=0; i<checkedBoxes.size(); i++)
{
JCheckBox checkedBox = checkedBoxes.elementAt(i);
String cBoxText = checkedBox.getText();
String objTypeName = cBoxText.substring(0, (cBoxText.indexOf('(') - 1));
String keyValStr = cBoxText.substring((cBoxText.indexOf('(') + 1), cBoxText.lastIndexOf(')'));

addParticipant(objTypeName, keyValStr);
}
setVisible(false);
dispose();
}
}
else if (source == checkAllButton) {
for (int i = 0; i < checkBoxes.size(); i++) {
checkBoxes.elementAt(i).setSelected(true);
}
}
else if (source == clearAllButton) {
for (int i = 0; i < checkBoxes.size(); i++) {
checkBoxes.elementAt(i).setSelected(false);
}
}
}

private void addParticipant(String objTypeName, String keyValStr)
{
if(objTypeName.equals("SoftwareEngineer"))
{
SoftwareEngineer a = state.getEmployeeStateRepository().getSoftwareEngineerStateRepository().get(keyValStr);
if(a != null)
{
if(action instanceof DesignAction)
{
if(partName.equals("Designer"))
{
((DesignAction)action).addDesigner(a);
}
}
else if(action instanceof DifficultyAnalysisAction)
{
if(partName.equals("Analyser"))
{
((DifficultyAnalysisAction)action).addAnalyser(a);
}
}
else if(action instanceof EvolveCodeAction)
{
if(partName.equals("Implementer"))
{
((EvolveCodeAction)action).addImplementer(a);
}
}
else if(action instanceof ImplementationAction)
{
if(partName.equals("Implementer"))
{
((ImplementationAction)action).addImplementer(a);
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Implementer"))
{
((IntegrateAction)action).addImplementer(a);
}
}
else if(action instanceof RequirementsAction)
{
if(partName.equals("ReqEngineer"))
{
((RequirementsAction)action).addReqEngineer(a);
}
}
else if(action instanceof RiskAnalysisAction)
{
if(partName.equals("Analyser"))
{
((RiskAnalysisAction)action).addAnalyser(a);
}
}
else if(action instanceof StartOverAction)
{
if(partName.equals("SEngineer"))
{
((StartOverAction)action).addSEngineer(a);
}
}
else if(action instanceof SubmitFinalAction)
{
if(partName.equals("Implementer"))
{
((SubmitFinalAction)action).addImplementer(a);
}
}
else if(action instanceof SubmitMultipleAction)
{
if(partName.equals("Implementer"))
{
((SubmitMultipleAction)action).addImplementer(a);
}
}
else if(action instanceof SubmitOneAction)
{
if(partName.equals("Implementer"))
{
((SubmitOneAction)action).addImplementer(a);
}
}
}
}
}

private void setMinAndMax()
{
if(action instanceof AdvanceChangeTicksAction)
{
if(partName.equals("Advance"))
{
minNumParts = 4;
maxNumParts = 4;
}
else if(partName.equals("SEngineer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof DesignAction)
{
if(partName.equals("Designer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("TheModule"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof DifficultyAnalysisAction)
{
if(partName.equals("Analyser"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("TheModule"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("TheProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof EveryTickAction)
{
if(partName.equals("Module"))
{
minNumParts = 4;
maxNumParts = 4;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof EvolveCodeAction)
{
if(partName.equals("Implementer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ImplementationAction)
{
if(partName.equals("Implementer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof InitialAction)
{
if(partName.equals("Module"))
{
minNumParts = 4;
maxNumParts = 4;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Implementer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof MakeChangeAction)
{
if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEngineer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof OverTimePentaltyAction)
{
if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof RequirementsAction)
{
if(partName.equals("ReqEngineer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof RevealDifficultyAction)
{
if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 999999;
}
}
else if(action instanceof RevealRisksAction)
{
if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof RiskAnalysisAction)
{
if(partName.equals("Analyser"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("TheProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof StartOverAction)
{
if(partName.equals("SEngineer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SubmitFinalAction)
{
if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 999999;
}
else if(partName.equals("Implementer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SubmitMultipleAction)
{
if(partName.equals("Module"))
{
minNumParts = 2;
maxNumParts = 999999;
}
else if(partName.equals("Implementer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("OtherModule"))
{
minNumParts = 0;
maxNumParts = 2;
}
}
else if(action instanceof SubmitOneAction)
{
if(partName.equals("Implementer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Module"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("SEProject"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("OtherModules"))
{
minNumParts = 0;
maxNumParts = 4;
}
}
}
public boolean actionCancelled()
{
return actionCancelled;
}

public class ExitListener extends WindowAdapter {
public void windowClosing(WindowEvent event) {
actionCancelled = true;
}
}
}
